package com.zipcodewilmington.looplabs;

import java.util.*;

/**
 * Created by leon on 1/29/18.
 * @ATTENTION_TO_STUDENTS You are forbidden from modifying the signature of this class.
 *  Given an object, `IntegerDuplicateDeleter`, with a composite `Integer[]` object, write a method
 *         * `removeDuplicatesExactly` which removes all values in the array which occur exactly
 *         the specified number of times.
 *         * `removeDuplicates` which removes all values in the array which occur
 *         at least the specified number of times.
 */
public final class IntegerDuplicateDeleter extends DuplicateDeleter<Integer> {
    ArrayList<Integer> list = new ArrayList<Integer>();

    public IntegerDuplicateDeleter(Integer[] intArray) {
        super(intArray);
    }

   @Override
    public Integer[] removeDuplicates(int maxNumberOfDuplications) {
        Arrays.sort (array);
       int n = array.length;
       int count = 0;
       int num=0;
       ArrayList<Integer>arraylist=new ArrayList<>() ;
       //Get all unique values
       HashSet set = new HashSet();
       for (int i=0; i < array.length;i++) {
           set.add(new Integer(array[i]));
       }

       Map<Integer,Integer>map=new HashMap<>();
       Iterator it = set.iterator();
       // Loop through the set for duplicates count and add it to Map
       Integer temp;
       while (it.hasNext()) {
           //initialize the counter to 0
           count = 0;
           temp = (Integer) it.next();

           //loop through the array sorted to count the duplicates

           for (int j = 0; j < n; j++) {

               if (temp.intValue() == array[j]) {

                   count++;


               }

           }

           map.put(temp, count);
       }

       for(Map.Entry<Integer,Integer>entry: map.entrySet()){
           if(entry.getValue().intValue() < maxNumberOfDuplications ){
               for (int i=0;  i< entry.getValue().intValue(); i++)
                   arraylist.add(entry.getKey() );

           }

       }
       Integer[] integers =arraylist.toArray(new  Integer[arraylist.size() ] ) ;     //return new Integer[0];

       return  integers ;


   }





    @Override
    public Integer[] removeDuplicatesExactly(int exactNumberOfDuplications) {
        Arrays.sort (array);
        int n = array.length;
        int count = 0;
        int num=0;
        ArrayList<Integer>arraylist=new ArrayList<>() ;
        //Get all unique values
        HashSet set = new HashSet();
        for (int i=0; i < array.length;i++) {
            set.add(new Integer(array[i]));
        }

        Map<Integer,Integer>map=new HashMap<>();
        Iterator it = set.iterator();
        // Loop through the set for duplicates count and add it to Map
        Integer temp;
        while (it.hasNext()) {
            //initialize the counter to 0
            count = 0;
            temp = (Integer) it.next();

            //loop through the array sorted to count the duplicates

            for (int j = 0; j < n; j++) {

                if (temp.intValue() == array[j]) {

                    count++;


                }

            }

            map.put(temp, count);
        }

        for(Map.Entry<Integer,Integer>entry: map.entrySet()){
            if(entry.getValue().intValue() != exactNumberOfDuplications){
                    for (int i=0;  i< entry.getValue().intValue(); i++)
                            arraylist.add(entry.getKey() );

            }

        }
             Integer[] integers =arraylist.toArray(new  Integer[arraylist.size() ] ) ;     //return new Integer[0];

        return  integers ;
    }


}